package com.yeejoin.amos.api.openapi.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

@AllArgsConstructor
@Getter
public enum FillingAfterFieldEnum {
    sequenceCode(true, true),
    fillingCheckId(true, true),
    withinScope(true, false),
    sealedState(true, false),
    defective(true, false),
    abnormalTemperature(true, false),
    warningSign(true, false),
    compliance(true, false),
    checkResults(true, false),
    nonconformances(true, false),
    inspector(true, false),
    inspectionDate(true, false),
    syncDate(true, false),
    syncState(true, false);

    private final boolean isRequire;
    private final boolean isUnique;

    public static List<String> getAllRequireKeys() {
        return Arrays.stream(values()).filter(e -> e.isRequire).map(Enum::name).collect(Collectors.toList());
    }

    public  static List<String> getAllUniqueKeys() {
        return Arrays.stream(values()).filter(e -> e.isUnique).map(Enum::name).collect(Collectors.toList());
    }
}
